﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.Mvc.Ajax;
using Microsoft.Web.Mvc;
namespace MvcApplication1Preview5.Controllers
{
    public class CategoriesController : Controller
    {
        public ActionResult Index()
        {
            var cats = from cat in new Models.NorthwindEntities().Categories
                       select cat;           
            return View(cats.ToList());
        }

        [AcceptVerbs("GET")]
        public ActionResult Create()
        {
            return View();
        }


        [ActionName("Create")]
        [AcceptVerbs("POST")]
        public ActionResult SaveNew(Models.Category cat)
        {
            /*var cat = new Models.Category();
            cat.CategoryName = CategoryName;
             */
            var db = new Models.NorthwindEntities();
            db.AddToCategories(cat);
            db.SaveChanges();
            db.Dispose();
            return RedirectToAction("Index");
        }

        [AcceptVerbs("GET")]
        public ActionResult Edit(int CategoryID)
        {
            var cat = (from cats in new Models.NorthwindEntities().Categories
                      where cats.CategoryID == CategoryID
                      select cats).First();
            return View(cat);
        }
        [ActionName("Edit")]
        [AcceptVerbs("POST")]
        public ActionResult SaveEdit(int categoryID)
        {
            bool atualizou;
            Models.Category catFromDB;
            using (var db = new Models.NorthwindEntities())
            {
                catFromDB = (from cats in db.Categories
                                 where cats.CategoryID == categoryID
                                 select cats).First();
                atualizou = TryUpdateModel(catFromDB, new[] { "CategoryName", "Description" });
                if (atualizou)
                    db.SaveChanges();
            }
            
            if (atualizou)
                return RedirectToAction("Edit", new { CategoryID = categoryID });
            else
                return View(catFromDB);
        }

        private void AtualizaErros(Models.Category cat)
        {
            //this.ViewData.ModelState.
        }
        /*
        [ActionName("Edit")]
        [AcceptVerbs("POST")]
        public ActionResult SaveEdit(Models.Category cat)
        {
            
            var db = new Models.NorthwindEntities();
            var key = db.CreateEntityKey("Categories", cat);
            object catFromDB;
            if (db.TryGetObjectByKey(key, out catFromDB))
            {
                TryUpdateModel(catFromDB, new [] {"CategoryID", "CategoryName"});
                db.ApplyPropertyChanges(key.EntitySetName, cat);
                db.SaveChanges();
            }
            db.Dispose();
            return RedirectToAction("Edit", new { CategoryID = cat.CategoryID });
        }      
        */
    }
}
