﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
namespace MvcApplication1Preview5.Models.Binders
{
    public class CategoryBinder : IModelBinder
    {

        #region IModelBinder Members

        public object GetValue(
            ControllerContext controllerContext, 
            string modelName, 
            Type modelType, 
            ModelStateDictionary modelState)
        {
            var cat = new Models.Category();
            HttpRequestBase request = controllerContext.HttpContext.Request;
            /*if (request["CategoryID"] != null)
                cat.CategoryID = Convert.ToInt32(request["CategoryID"]);*/
            cat.CategoryName = request["CategoryName"];
            modelState.AddModelError("CategoryName", cat.CategoryName, "O valor de CategoryName é obrigatório.");
            cat.Description = request["Description"];
            return cat;                
        }

        #endregion
    }
}
