﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace MvcApplication1Preview5.Models
{
    //[ModelBinder(typeof(Microsoft.Web.Mvc.ComplexModelBinder))]
    [ModelBinder(typeof(Binders.CategoryBinder))]
    public partial class Category
    {
        partial void OnCategoryNameChanging(string value)
        {
            if (string.IsNullOrEmpty(value))
            {
                LancaErro("O valor de CategoryName é obrigatório.");
            }
        }
        partial void OnDescriptionChanging(string value)
        {
            if (string.IsNullOrEmpty(value))
            {
                LancaErro("O valor de Description é obrigatório.");
            }
        }

        private void LancaErro(string textoErro)
        {
            Erros.Add(textoErro);
            throw new ApplicationException(textoErro);
        }

        public IList<string> Erros = new List<string>();

    }
}
